var Util = {};

Util.clone = function(jsonObject){
    return JSON.parse(JSON.stringify(jsonObject));
};

Util.get = function(obj, pathToProperty, defaultValue){
    var pathDoesNotExists = false;

    var value = obj;
    for (var i = 0; i < pathToProperty.length && !pathDoesNotExists; i++){
        if(typeof value === 'object'){
            value = value[pathToProperty[i]];
        } else {
            pathDoesNotExists = true;
        }
    }

    return pathDoesNotExists || value === undefined ? defaultValue : value;
};

Util.isArray = function(value){
    return Array.isArray(value);
};

Util.isUndefined = function(value){
    return typeof(value) === "undefined";
};

Util.isNull = function(value){
    return value === null;
};

Util.isUndefinedOrNull = function(value){
    return Util.isUndefined(value) || Util.isNull(value);
};

Util.isEmptyOrBlank = function(value){
    return Util.isUndefinedOrNull(value) || value.toString().trim().length === 0;
};
